#!/usr/bin/perl

#------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $FORM{'main_file'}){ $stat_info .= (":  ".$FORM{'main_file'}."<br>       !<br>"); reset_document(); };
  open FILE,$FORM{'main_file'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub get_date
 {
  ($day, $mn, $yr) = (localtime)[3..5];
  if($day < 10){ $day = "0".$day; };
  $mn = ($mn < 10) ? "0".($mn + 1) : $mn + 1;
  if($yr < 2000){ $yr += 1900; };
  return $day."-".$mn."-".$yr;
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.save_as_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";

$stat_info .= ("   ".$FORM{'main_file'}."    ...<br>");

#  
if(!-r $FORM{'main_file'})
 {
  $stat_info .= (":  ".$FORM{'main_file'}."       !<br>");
  reset_document();
 };
open FILE,$FORM{'main_file'};
#     ( )
(undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
#  
close FILE;
$stat_info .= ("->     ... ");
read_block(0,20,$header);
#   
$file_type = substr $header,0,4;
if($file_type ne "TLK ")
 { $stat_info .= (":   ".$file_type."   !<br>"); reset_document(); };
#  
$file_version = substr $header,4,4;
#     
$file_strings = ($file_version eq "V3.0") ? get_DWORD($header,12) - 1 : get_DWORD($header,10) - 1;
#        
$strings_offset = ($file_version eq "V3.0") ? get_DWORD($header,16) : get_DWORD($header,14);

if($file_version eq "V3.0"){ $header_length = 20; $string_data_length = 40; }
else{ $header_length = 18; $string_data_length = 26; }
#      
if($FORM{'string_number'} > $file_strings){ $FORM{'string_number'} = $file_strings; };

$stat_info .= ("->       ... ");
read_block($header_length,$strings_offset-$header_length,$strings_data_table);
$stat_info .= ("->     ... ");
read_block($strings_offset,$file_size-$strings_offset,$strings_content);
  
#    
my $start_position = $FORM{'processing_start_position'};

#    
my $end_position = $FORM{'processing_end_position'};

#    
my $file_content;

#  
my $file_extention;

#   
my $processed_strings = 0;

#    tlk-
my $source_file_name = $FORM{'main_file'}; $source_file_name =~ s/\.tlk//;

#      
if($FORM{'matched_strings_joined'} ne "")
 #  :     
 {
  #     
  my @matched_strings = split ",",$FORM{'matched_strings_joined'};

  if($FORM{'saving_format'} eq "own_txt")
   {
    $file_extention = "txt";
    if($file_version eq "V3.0")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
          my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
          $file_content .= ("StringRef: ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n\n");
          $processed_strings++;
         }
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
          my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
          $file_content .= ("StringRef: ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n\n");
          $processed_strings++;
         }
       }
     }
   }
  elsif($FORM{'saving_format'} eq "teambg_txt")
   {
    $file_extention = "txt";
    if($file_version eq "V3.0")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_Flags = substr $strings_data_table,40*$n,4;
          my $current_SoundResRef = substr $strings_data_table,40*$n+4,8;
          my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
          my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
          my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
          my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);

          #      
          $new_data_table .= get_WORD_symbols(get_DWORD($current_Flags)).$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols($strings_length).get_DWORD_symbols($current_StringSize);
          #     
          $strings_length += $current_StringSize;

          my $output_number = "000000".$processed_strings;
          $file_content .= ("<".(substr $output_number,-7).">".(substr $strings_content,$current_OffsetToString,$current_StringSize)."<END>\r\n");
          #  
          $processed_strings++;
         }
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_Flags = substr $strings_data_table,26*$n,2;
          my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
          my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
          my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
          my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
          my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);

          $new_data_table .= $current_Flags.$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols($strings_length).get_DWORD_symbols($current_StringSize);
          $strings_length += $current_StringSize;

          my $output_number = "000000".$processed_strings;
          $file_content .= ("<".(substr $output_number,-7).">".(substr $strings_content,$current_OffsetToString,$current_StringSize)."<END>\r\n");

          $processed_strings++;
         }
       }
     }
    #     
    if((length $new_data_table)/26 ne $processed_strings)
     { $stat_info .= (":      !<br>"); reset_document(); };
    #    bin-
    $new_file_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_strings).get_DWORD_symbols(18+$processed_strings*26);
    #    bin-
    if(length $new_file_header ne 18)
     { $stat_info .= (":    !<br>"); reset_document(); };
    #    
    if($file_content eq "")
     { $stat_info .= (":     bin-!<br>"); reset_document(); };
    #    bin-
    my $data_file = ($FORM{'add_date_on_save'} eq 1) ? ($source_file_name."_".get_date().".".$file_extention.".bin") : ($source_file_name.".".$file_extention.".bin");
    #     bin-
    if(-r $data_file)
     {
      if(!-w $data_file)
       { $stat_info .= (":  ".$data_file."    !<br>"); reset_document(); };
      if($FORM{'make_backup'} eq 1)
       {
        rename $data_file, $data_file.".bak";
        $stat_info .= ("->      ".$data_file.".bak<br>");
       };
     };
    open FILE,">".$data_file;
    binmode FILE; print FILE $new_file_header.$new_data_table; close FILE;
   }
  elsif($FORM{'saving_format'} eq "hack_proj_patch")
   {
    $file_extention = "patch";
    if($file_version eq "V3.0")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
          my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
          $file_content .= ("> ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n");
          $processed_strings++;
         }
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
          my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
          $file_content .= ("> ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n");
          $processed_strings++;
         }
       }
     }
   }
  elsif($FORM{'saving_format'} eq "weidu_tra")
   {
    $file_extention = "tra";
    if($file_version eq "V3.0")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
          my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
          my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
             $current_string =~ s/~/{tilde}/g;
          $file_content .= ("@".$n." = ~".$current_String."~\n");
          $processed_strings++;
         };
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
          my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
          my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
             $current_string =~ s/~/{tilde}/g;
          $file_content .= ("@".$n." = ~".$current_String."~\n");
          $processed_strings++;
         };
       }
     }
   }
  elsif($FORM{'saving_format'} eq "native_tlk_1")
   {
    $file_extention = "tlk";
    my $new_header;
    my $new_data_table;
    my $new_strings_table;
    if($file_version eq "V3.0")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_Flags = substr $strings_data_table,40*$n,4;
          my $current_SoundResRef = substr $strings_data_table,40*$n+4,8;
          my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
          my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
          my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
          my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
          #my $current_SoundLength = substr $strings_data_table,40*$n+36,4;
          $new_data_table .= get_WORD_symbols(get_DWORD($current_Flags)).$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols($current_StringSize);
          $new_strings_table .= (substr $strings_content,$current_OffsetToString,$current_StringSize);
          $processed_strings++;
         };
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_Flags = substr $strings_data_table,26*$n,2;
          my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
          my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
          my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
          my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
          my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
          $new_data_table .= $current_Flags.$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols($current_StringSize);
          $new_strings_table .= (substr $strings_content,$current_OffsetToString,$current_StringSize);
          $processed_strings++;
         };
       }
     }
    if((length $new_data_table)/26 ne $processed_strings)
     { $stat_info .= (":      !<br>"); reset_document(); };
    if($new_strings_table eq "")
     { $stat_info .= (":    !<br>"); reset_document(); };
    $new_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_strings).get_DWORD_symbols(18+$processed_strings*26);
    if(length $new_header ne 18)
     { $stat_info .= (":    !<br>"); reset_document(); };
    $file_content = $new_header.$new_data_table.$new_strings_table;
    $source_file_name .= ("-user[".$processed_strings."]");
   }
  elsif($FORM{'saving_format'} eq "native_tlk_3")
   {
    $file_extention = "tlk";
    my $new_header;
    my $new_data_table;
    my $new_strings_table;
    if($file_version eq "V3.0")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_Flags = substr $strings_data_table,40*$n,4;
          my $current_SoundResRef = substr $strings_data_table,40*$n+4,16;
          my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
          my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
          my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
          my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
          my $current_SoundLength = substr $strings_data_table,40*$n+36,4;
          $new_data_table .= $current_Flags.$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols($current_StringSize).$current_SoundLength;
          $new_strings_table .= (substr $strings_content,$current_OffsetToString,$current_StringSize);
          $processed_strings++;
         };
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n (@matched_strings)
       {
        if(($start_position <= $n) && ($n <= $end_position))
         {
          my $current_Flags = substr $strings_data_table,26*$n,2;
          my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
          my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
          my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
          my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
          my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
          $new_data_table .= get_DWORD_symbols(get_WORD($current_Flags)).$current_SoundResRef.get_DWORD_symbols(0).get_DWORD_symbols(0).$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols($current_StringSize).(pack "f", 0);
          $new_strings_table .= (substr $strings_content,$current_OffsetToString,$current_StringSize);
          $processed_strings++;
         };
       }
     }
    if((length $new_data_table)/40 ne $processed_strings)
     { $stat_info .= (":      !<br>"); reset_document(); };
    if($new_strings_table eq "")
     { $stat_info .= (":    !<br>"); reset_document(); };
    $new_header = "TLK "."V3.0".get_DWORD_symbols(0).get_DWORD_symbols($processed_strings).get_DWORD_symbols(20+$processed_strings*40);
    if(length $new_header ne 20)
     { $stat_info .= (":    !<br>"); reset_document(); };
    $file_content = $new_header.$new_data_table.$new_strings_table;
    $source_file_name .= ("-user[".$processed_strings."]");
   }
 }
 #  :     
else
 #  :    
 {
  if($FORM{'saving_format'} eq "own_txt")
   {
    $file_extention = "txt";
    if($file_version eq "V3.0")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
        $file_content .= ("StringRef: ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n\n");
        $processed_strings++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
        $file_content .= ("StringRef: ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n\n");
        $processed_strings++;
       }
     }
   }
  elsif($FORM{'saving_format'} eq "teambg_txt")
   #  :       TeamBG
   {
    $file_extention = "txt";
    if($file_version eq "V3.0")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_Flags = substr $strings_data_table,40*$n,4;
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8;
        my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
        my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);

        #      
        $new_data_table .= get_WORD_symbols(get_DWORD($current_Flags)).$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols($strings_length).get_DWORD_symbols($current_StringSize);
        #     
        $strings_length += $current_StringSize;

        my $output_number = "000000".$processed_strings;
        $file_content .= ("<".(substr $output_number,-7).">".(substr $strings_content,$current_OffsetToString,$current_StringSize)."<END>\r\n");
        #  
        $processed_strings++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_Flags = substr $strings_data_table,26*$n,2;
        my $current_SoundResRef = substr $strings_data_table,26*$n+4,8;
        my $current_VolumeVariance = substr $strings_data_table,26*$n+20,4;
        my $current_PitchVariance = substr $strings_data_table,26*$n+24,4;
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);

        #      
        $new_data_table .= $current_Flags.$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols($strings_length).get_DWORD_symbols($current_StringSize);
        #     
        $strings_length += $current_StringSize;

        my $output_number = "000000".$processed_strings;
        $file_content .= ("<".(substr $output_number,-7).">".(substr $strings_content,$current_OffsetToString,$current_StringSize)."<END>\r\n");
        #  
        $processed_strings++;
       }
     }
    #     
    if((length $new_data_table)/26 ne $processed_strings)
     { $stat_info .= (":      !<br>"); reset_document(); };
    #    bin-
    $new_file_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_strings).get_DWORD_symbols(18+$processed_strings*26);
    #    bin-
    if(length $new_file_header ne 18)
     { $stat_info .= (":    !<br>"); reset_document(); };
    #    
    if($file_content eq "")
     { $stat_info .= (":     bin-!<br>"); reset_document(); };
    #    bin-
    my $data_file = ($FORM{'add_date_on_save'} eq 1) ? ($source_file_name."_".get_date().".".$file_extention.".bin") : ($source_file_name.".".$file_extention.".bin");
    #     bin-
    if(-r $data_file)
     {
      if(!-w $data_file)
       { $stat_info .= (":  ".$data_file."    !<br>"); reset_document(); };
      if($FORM{'make_backup'} eq 1)
       {
        rename $data_file, $data_file.".bak";
        $stat_info .= ("->      ".$data_file.".bak<br>");
       };
     };
    open FILE,">".$data_file;
    binmode FILE; print FILE $new_file_header.$new_data_table; close FILE;
   }
   #  :       TeamBG
  elsif($FORM{'saving_format'} eq "hack_proj_patch")
   {
    $file_extention = "patch";
    if($file_version eq "V3.0")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
        $file_content .= ("> ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n");
        $processed_strings++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
        $file_content .= ("> ".$n."\n".(substr $strings_content,$current_OffsetToString,$current_StringSize)."\n");
        $processed_strings++;
       }
     }
   }
  elsif($FORM{'saving_format'} eq "weidu_tra")
   {
    $file_extention = "tra";
    if($file_version eq "V3.0")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
        my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
        $current_string =~ s/~/{tilde}/g;
        $file_content .= ("@".$n." = ~".$current_String."~\n");
        $processed_strings++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
        my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
        $current_string =~ s/~/{tilde}/g;
        $file_content .= ("@".$n." = ~".$current_String."~\n");
        $processed_strings++;
       }
     }
   }
  elsif($FORM{'saving_format'} eq "native_tlk_1")
   {
    $file_extention = "tlk";
    my $new_header;
    my $new_data_table;
    my $new_strings_table;
    if($file_version eq "V3.0")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_Flags = substr $strings_data_table,40*$n,4;
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,8;
        my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
        my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
        #my $current_SoundLength = substr $strings_data_table,40*$n+36,4;
        my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
        $new_data_table .= get_WORD_symbols(get_DWORD($current_Flags)).$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $current_String);
        $new_strings_table .= $current_String;
        $processed_strings++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_Flags = substr $strings_data_table,26*$n,2;
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
        my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
        my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
        my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
        $new_data_table .= $current_Flags.$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $current_String);
        $new_strings_table .= $current_String;
        $processed_strings++;
       }
     }
    if((length $new_data_table)/26 ne $processed_strings)
     { $stat_info .= (":      !<br>"); reset_document(); };
    if($new_strings_table eq "")
     { $stat_info .= (":    !<br>"); reset_document(); };
    $new_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_strings).get_DWORD_symbols(18+$processed_strings*26);
    if(length $new_header ne 18)
     { $stat_info .= (":    !<br>"); reset_document(); };
    $file_content = $new_header.$new_data_table.$new_strings_table;
    $source_file_name .= ("-user[".$processed_strings."]");
   }
  elsif($FORM{'saving_format'} eq "native_tlk_3")
   {
    $file_extention = "tlk";
    my $new_header;
    my $new_data_table;
    my $new_strings_table;
    if($file_version eq "V3.0")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_Flags = substr $strings_data_table,40*$n,4;
        my $current_SoundResRef = substr $strings_data_table,40*$n+4,16;
        my $current_VolumeVariance = substr $strings_data_table,40*$n+20,4;
        my $current_PitchVariance = substr $strings_data_table,40*$n+24,4;
        my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
        my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
        my $current_SoundLength = substr $strings_data_table,40*$n+36,4;
        my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
        $new_data_table .= $current_Flags.$current_SoundResRef.$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $current_String).$current_SoundLength;
        $new_strings_table .= $current_String;
        $processed_strings++;
       }
     }
    elsif($file_version eq "V1  ")
     {
      for my $n ($start_position..$end_position)
       {
        my $current_Flags = substr $strings_data_table,26*$n,2;
        my $current_SoundResRef = substr $strings_data_table,26*$n+2,8;
        my $current_VolumeVariance = substr $strings_data_table,26*$n+10,4;
        my $current_PitchVariance = substr $strings_data_table,26*$n+14,4;
        my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
        my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
        my $current_String = substr $strings_content,$current_OffsetToString,$current_StringSize;
        $new_data_table .= get_DWORD_symbols(get_WORD($current_Flags)).$current_SoundResRef.get_DWORD_symbols(0).get_DWORD_symbols(0).$current_VolumeVariance.$current_PitchVariance.get_DWORD_symbols(length $new_strings_table).get_DWORD_symbols(length $current_String).(pack "f", 0);
        $new_strings_table .= $current_String;
        $processed_strings++;
       }
     }
    if((length $new_data_table)/40 ne $processed_strings)
     { $stat_info .= (":      !<br>"); reset_document(); };
    if($new_strings_table eq "")
     { $stat_info .= (":    !<br>"); reset_document(); };
    $new_header = "TLK "."V3.0".get_DWORD_symbols(0).get_DWORD_symbols($processed_strings).get_DWORD_symbols(20+$processed_strings*40);
    if(length $new_header ne 20)
     { $stat_info .= (":    !<br>"); reset_document(); };
    $file_content = $new_header.$new_data_table.$new_strings_table;
    $source_file_name .= ("-user[".$processed_strings."]");
   }
 }
 #  :    

#  
if($file_content eq "")
 { $stat_info .= (":    ,   !<br>"); reset_document(); };

#   
my $current_date = get_date();
my $current_file_name = ($FORM{'add_date_on_save'} eq 1 && !($source_file_name =~ /$current_date/)) ? $source_file_name."_".$current_date.".".$file_extention : $source_file_name.".".$file_extention;

#   
if(-r $current_file_name)
 {
  if(!-w $current_file_name)
   { $stat_info .= (":  ".$current_file_name."    !<br>"); reset_document(); };
  if($FORM{'make_backup'} eq 1)
   {
    rename $current_file_name, $current_file_name.".bak";
    $stat_info .= ("->      ".$current_file_name.".bak<br>");
   };
 };

#   ( )  tra-
if($FORM{'saving_format'} eq "weidu_tra")
 {
  #       $1
  $current_file_name =~ /([^\.\\]{1,}\.tra)$/;
  $file_content = "\n/* ".$1." */\n\n".$file_content;
 };

#  
open FILE,">".$current_file_name; binmode FILE; print FILE $file_content; close FILE;

#  
$stat_info .= ("->  ".$file_extention."-: ".$current_file_name."<br>->    tlk-: ".$processed_strings." ... ".(length $file_content)." <br>");

# 
reset_document();