#!/usr/bin/perl

#------------------------------------------------------------#
read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $buffer);
foreach $pair (@pairs) 
 {
  ($name, $value) = split(/=/, $pair);
  $value =~ tr/+/ /;
  $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  $FORM{$name} = $value;
 }
$temp = $ENV{'QUERY_STRING'};
@pairs = split(/&/,$temp);
foreach $item(@pairs) 
 {
  ($key, $content) = split (/=/, $item, 2);
  $content =~ tr/+/ /;
  $content =~ s/%(..)/pack("c",hex($1))/ge;
  $FORM{$key} = $content;
 }
#------------------------------------------------------------#
sub get_WORD
 { return unpack "v", (substr $_[0],$_[1],4); }

sub get_DWORD
 { return unpack "V", (substr $_[0],$_[1],4); }

sub get_WORD_symbols
 { return pack "v", $_[0]; }

sub get_DWORD_symbols
 { return pack "V", $_[0]; }

sub read_block
 {
  if(!-r $FORM{'main_file'}){ $stat_info .= (":  ".$FORM{'main_file'}."<br>       !<br>"); reset_document(); };
  open FILE,$FORM{'main_file'};
  $stat_info .= ($_[1]."    ".$_[0]."<br>");
  binmode FILE;
  seek FILE,$_[0],0; read FILE,$_[2],$_[1];
  close FILE;
 }

sub get_time
 {
  ($sec, $min, $hour) = (localtime)[0..2];
  if($sec < 10){ $sec = "0$sec"; };
  if($min < 10){ $min = "0$min"; };
  if($hour < 10){ $hour = "0$hour"; };
  return "$hour:$min:$sec";
 }

sub reset_document
 {
  $stat_info =~ s/\x5c/\\x5c/g;
  my $full_stat_info = "<b><font color='green'>".get_time()."</font></b><blockquote style='border: solid 1px gray; margin: 2px 10px 2px 10px; padding: 2px 4px 2px 4px;'>".$stat_info."  :&nbsp;<span id='span_stat_info'></span>&nbsp;.</blockquote>";
  print <<HTML;
  <script type='text/javascript'><!--
  parent.document.getElementById("stat_info").innerHTML = ("$FORM{'full_stat'}" == 1) ? ("$full_stat_info" + parent.document.getElementById("stat_info").innerHTML) : "$full_stat_info";
  parent.document.save_changes_form.reset();
  parent.FLAG_no_action = 0;
  parent.document.getElementById("span_stat_info").innerHTML = (Math.round((parent.get_request_time() - parent.request_start_time)*Math.pow(10,parent.float_precision)))/Math.pow(10,parent.float_precision);
  // --></script>
HTML

  exit;
 }
#-----------------------------------------------------------------------#
print "content-type: text/html; charset=Windows-1251\n\n";

#     
my @patch_strings = split ",",$FORM{'patched_strings_joined'};

#     
my @patch_content;

#       tlk-
if($FORM{'patched_contents_joined'} eq "{!command_get_contents!}")
 {
  #  tlk-
  if(!-r $FORM{'main_file'})
   {
    $stat_info .= (":  ".$FORM{'main_file'}."       !<br>");
    reset_document();
   };
  open FILE,$FORM{'main_file'};
  #     ( )
  (undef, undef, undef, undef, undef, undef, undef, $file_size) = stat FILE;
  #  
  close FILE;
  $stat_info .= ("   ... ");
  #  
  my $header;
  read_block(0,20,$header);
  #   
  my $file_type = substr $header,0,4;
  if($file_type ne "TLK ")
   { $stat_info .= (":   ".$file_type."   !<br>"); reset_document(); };
  #  
  my $file_version = substr $header,4,4;
  
  if($file_version eq "V3.0")
   {
    #     
    my $file_strings = get_DWORD($header,12) - 1;
    #        
    my $strings_offset = get_DWORD($header,16);

    $stat_info .= ("->      ... ");
    my $strings_data_table;
    read_block(20,$strings_offset-20,$strings_data_table);
    $stat_info .= ("->     ... ");
    my $strings_content;
    read_block($strings_offset,$file_size-$strings_offset,$strings_content);

    for my $n (@patch_strings)
     {
      my $current_OffsetToString = get_DWORD($strings_data_table,40*$n+28);
      my $current_StringSize = get_DWORD($strings_data_table,40*$n+32);
      push @patch_content,(substr $strings_content,$current_OffsetToString,$current_StringSize);
     }
   }
  elsif($file_version eq "V1  ")
   {
    my $file_strings = get_DWORD($header,10) - 1;
    my $strings_offset = get_DWORD($header,14);

    $stat_info .= ("->      ... ");
    my $strings_data_table;
    read_block(18,$strings_offset-18,$strings_data_table);
    $stat_info .= ("->     ... ");
    my $strings_content;
    read_block($strings_offset,$file_size-$strings_offset,$strings_content);

    for my $n (@patch_strings)
     {
      my $current_OffsetToString = get_DWORD($strings_data_table,26*$n+18);
      my $current_StringSize = get_DWORD($strings_data_table,26*$n+22);
      push @patch_content,(substr $strings_content,$current_OffsetToString,$current_StringSize);
     }
   }
 };

if($FORM{'patched_contents_joined'} ne "{!command_numbers_only!}")
 {
  #   
  my $processed_string;
  #     
  if($#patch_content eq "-1")
   { @patch_content = split "{!join!}",$FORM{'patched_contents_joined'}; }

  # -:  =  ;  =  
  my %patch_elements;
  if($FORM{'sorting_by_string_number'} eq 1)
   { for my $cn (0..$#patch_strings){ $patch_elements{$patch_strings[$cn]} = @patch_content[$cn]; } };

  #    
  my $patch_content;
  if($FORM{'patch_format'} eq "own_txt")
   {
    $stat_info .= ("   txt- ( ) ...<br>");
    if($FORM{'sorting_by_string_number'} eq 1)
     {
      $stat_info .= ("->     <br>");
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       { $patch_content .= ("StringRef: ".$cn."\n".$patch_elements{$cn}."\n\n"); $processed_string++; }
     }
    elsif($FORM{'sorting_by_string_number'} eq 0)
     {
      $stat_info .= ("->      <br>");
      foreach my $cn (0..$#patch_strings)
       { $patch_content .= ("StringRef: ".@patch_strings[$cn]."\n".@patch_content[$cn]."\n\n"); $processed_string++; }
     }
   }
  elsif($FORM{'patch_format'} eq "teambg_txt")
   {
    $stat_info .= ("   txt- ( TeamBG BG2 TLK Editor) ...<br>");
    $processed_string = 0;
    if($FORM{'sorting_by_string_number'} eq 1)
     {
      $stat_info .= ("->     <br>");
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        #   
        $string_content = $patch_elements{$cn};

        #    
        if($string_content =~ /<[^ \n]{1}[^>\n]*>/){ $string_flag = get_WORD_symbols(7); }
        elsif(ord $string_content){ $string_flag = get_WORD_symbols(3); }
        else{ $string_flag = get_WORD_symbols(0); }
        #     
        $string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
        #    
        $strings_data_table .= $string_flag.$string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $string_content);
        #   
        $strings_content .= $string_content;

        #       
        $in_patch_string_number = "000000".$processed_string;
        #   
        $patch_content .= ("<".(substr $in_patch_string_number,-7).">".$string_content."<END>\r\n");
        $processed_string++;
       }
     }
    elsif($FORM{'sorting_by_string_number'} eq 0)
     {
      $stat_info .= ("->      <br>");
      foreach my $cn (@patch_content)
       {
        #   
        $string_content = $cn;

        #    
        if($string_content =~ /<[^ \n]{1}[^>\n]*>/){ $string_flag = get_WORD_symbols(7); }
        elsif(ord $string_content){ $string_flag = get_WORD_symbols(3); }
        else{ $string_flag = get_WORD_symbols(0); }
        #     
        $string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
        #    
        $strings_data_table .= $string_flag.$string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $string_content);
        #   
        $strings_content .= $string_content;

        #       
        $in_patch_string_number = "000000".$processed_string;
        #   
        $patch_content .= ("<".(substr $in_patch_string_number,-7).">".$string_content."<END>\r\n");
        $processed_string++;
       }
     }
    #     
    if((length $strings_data_table)/26 ne $processed_string)
     { $stat_info .= (":      !<br>"); reset_document(); };
    #   
    $file_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_string).get_DWORD_symbols(18+$processed_string*26);
    if(length $file_header ne 18)
     { $stat_info .= (":    !<br>"); reset_document(); };
    #   bin-
    $data_file = $FORM{'save_patch_path'}.".bin";
    #    
    if(-r $data_file)
     {
      if(!-w $data_file)
       { $stat_info .= (":  ".$data_file."    !<br>"); reset_document(); };
      if($FORM{'make_backup'} eq 1)
       {
        rename $data_file, ($data_file.".bak");
        $stat_info .= (" : ".$data_file.".bak<br>");
       };
     };
    open FILE,">".$data_file;
    binmode FILE; print FILE $file_header.$strings_data_table; close FILE;
   }
  elsif($FORM{'patch_format'} eq "hack_proj_patch")
   {
    $stat_info .= ("   patch- ( BG File Format Hacking Project) ...<br>");
    if($FORM{'sorting_by_string_number'} eq 1)
     {
      $stat_info .= ("->     <br>");
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        $patch_content .= ("> ".$cn."\n".$patch_elements{$cn}."\n");
        $processed_string++;
       }
     }
    elsif($FORM{'sorting_by_string_number'} eq 0)
     {
      $stat_info .= ("->      <br>");
      foreach my $cn (0..$#patch_strings)
       {
        $patch_content .= ("> ".@patch_strings[$cn]."\n".@patch_content[$cn]."\n");
        $processed_string++;
       }
     }
   }
  elsif($FORM{'patch_format'} eq "weidu_tra")
   {
    $stat_info .= ("   tra- (WeiDU-) ...<br>");
    if($FORM{'sorting_by_string_number'} eq 1)
     {
      $stat_info .= ("->     <br>");
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        #    
        $patch_elements{$cn} =~ s/~/{tilde}/g;
        $patch_content .= ("@".$cn." = ~".$patch_elements{$cn}."~\n");
        $processed_string++;
       }
     }
    elsif($FORM{'sorting_by_string_number'} eq 0)
     {
      $stat_info .= ("->      <br>");
      foreach my $cn (0..$#patch_strings)
       {
        #    
        $patch_elements{$cn} =~ s/~/{tilde}/g;
        $patch_content .= ("@".@patch_strings[$cn]." = ~".@patch_content[$cn]."~\n");
        $processed_string++;
       }
     }
   }
  elsif($FORM{'patch_format'} eq "native_tlk_1")
   {
    $stat_info .= ("   tlk- ( V1) ...<br>");
    if($FORM{'sorting_by_string_number'} eq 1)
     {
      $stat_info .= ("->     <br>");
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        #   
        $string_content = $patch_elements{$cn};
        #   
        $string_content =~ s/\r//g;
        #    
        if($string_content =~ /<[^ \n]{1}[^>\n]*>/){ $string_flag = get_WORD_symbols(7); }
        elsif(ord $string_content){ $string_flag = get_WORD_symbols(3); }
        else{ $string_flag = get_WORD_symbols(0); }
        #     
        $string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
        #    
        $strings_data_table .= $string_flag.$string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $string_content);
        #   
        $strings_content .= $string_content;
        $processed_string++;
       }
     }
    elsif($FORM{'sorting_by_string_number'} eq 0)
     {
      $stat_info .= ("->      <br>");
      foreach my $cn (@patch_content)
       {
        #   
        $string_content = $patch_elements{$cn};
        #   
        $string_content =~ s/\r//g;
        #    
        if($string_content =~ /<[^ \n]{1}[^>\n]*>/){ $string_flag = get_WORD_symbols(7); }
        elsif(ord $string_content){ $string_flag = get_WORD_symbols(3); }
        else{ $string_flag = get_WORD_symbols(0); }
        #     
        $string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0);
        #    
        $strings_data_table .= $string_flag.$string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $string_content);
        #   
        $strings_content .= $string_content;
        $processed_string++;
       }
     }
    #     
    if((length $strings_data_table)/26 ne $processed_string)
     { $stat_info .= (":      !<br>"); reset_document(); };
    #   
    $file_header = "TLK "."V1  ".get_WORD_symbols(0).get_DWORD_symbols($processed_string).get_DWORD_symbols(18+$processed_string*26);
    if(length $file_header ne 18)
     { $stat_info .= (":    !<br>"); reset_document(); };
    #   
    $patch_content = $file_header.$strings_data_table.$strings_content;
   }
  elsif($FORM{'patch_format'} eq "native_tlk_3")
   {
    $stat_info .= ("   tlk- ( V3.0) ...<br>");
    if($FORM{'sorting_by_string_number'} eq 1)
     {
      $stat_info .= ("->     <br>");
      foreach my $cn (sort {$a <=> $b} keys %patch_elements)
       {
        #   
        $string_content = $patch_elements{$cn};
        #   
        $string_content =~ s/\r//g;
        #    
        $string_flag = (ord $string_content) ? get_DWORD_symbols(1) : get_DWORD_symbols(0);
        #     
        $string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0);
        #    
        $strings_data_table .= $string_flag.$string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $string_content).get_DWORD_symbols(0);
        #   
        $strings_content .= $string_content;
        $processed_string++;
       }
     }
    elsif($FORM{'sorting_by_string_number'} eq 0)
     {
      $stat_info .= ("->      <br>");
      foreach my $cn (@patch_content)
       {
        #   
        $string_content = $cn;
        #   
        $string_content =~ s/\r//g;
        #    
        $string_flag = (ord $string_content) ? get_DWORD_symbols(1) : get_DWORD_symbols(0);
        #     
        $string_sound_link = get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(0);
        #    
        $strings_data_table .= $string_flag.$string_sound_link.get_DWORD_symbols(0).get_DWORD_symbols(0).get_DWORD_symbols(length $strings_content).get_DWORD_symbols(length $string_content).get_DWORD_symbols(0);
        #   
        $strings_content .= $string_content;
        $processed_string++;
       }
     }
    #     
    if((length $strings_data_table)/40 ne $processed_string)
     { $stat_info .= (":      !<br>"); reset_document(); };
    #   
    $file_header = "TLK "."V3.0".get_DWORD_symbols(0).get_DWORD_symbols($processed_string).get_DWORD_symbols(20+$processed_string*40);
    if(length $file_header ne 20)
     { $stat_info .= (":    !<br>"); reset_document(); };
    #   
    $patch_content = $file_header.$strings_data_table.$strings_content;
   }

  if(-r $FORM{'save_patch_path'})
   {
    if(!-w $FORM{'save_patch_path'})
     { $stat_info .= (":  ".$FORM{'save_patch_path'}."    !<br>"); reset_document(); };
    if($FORM{'make_backup'} eq 1)
     {
      rename $FORM{'save_patch_path'}, ($FORM{'save_patch_path'}.".bak");
      $stat_info .= ("    ".$FORM{'save_patch_path'}.".bak<br>");
     };
   };
  open FILE,">".$FORM{'save_patch_path'};
  binmode FILE; print FILE $patch_content; close FILE;
  $stat_info .= (" : ".$FORM{'save_patch_path'}."<br>->  : ".$processed_string." ... ".(length $patch_content)." <br>");
 }
elsif($FORM{'patched_contents_joined'} eq "{!command_numbers_only!}")
 {
  $stat_info .= ("   tlk-  num- ...<br>");
  #   
  my $processed_string;
  if($FORM{'sorting_by_string_number'} eq 1)
   {
    $stat_info .= ("->     <br>");
    foreach my $cn (sort {$a <=> $b} @patch_strings){ $patch_content .= ($cn.","); $processed_string++; };
   }
  elsif($FORM{'sorting_by_string_number'} eq 0)
   {
    $stat_info .= ("->      <br>");
    foreach my $cn (@patch_strings){ $patch_content .= ($cn.","); $processed_string++; };
   }
  #    (,)
  chop($patch_content);
  if(-r $FORM{'save_patch_path'})
   {
    if(!-w $FORM{'save_patch_path'})
     { $stat_info .= (":  ".$FORM{'save_patch_path'}."    !<br>"); reset_document(); };
    if($FORM{'make_backup'} eq 1)
     {
      rename $FORM{'save_patch_path'}, ($FORM{'save_patch_path'}.".bak");
      $stat_info .= ("    ".$FORM{'save_patch_path'}.".bak<br>");
     };
   };
  open FILE,">".$FORM{'save_patch_path'};
  binmode FILE; print FILE $patch_content; close FILE;
  $stat_info .= (" : ".$FORM{'save_patch_path'}."<br>->  : ".$processed_string." ... ".(length $patch_content)." <br>");
 }
reset_document();
